   '***********************************************************************
   ' Digitln hodiny, alarm, teplomr
   '
   ' DS3231 + zalozni bat3V                - RTC Extremely Accurate I2C-Integrated RTC/TCXO/Crystal
   ' DS18B20 (-55 a + 99,9C)             - teplota
   ' nastaveni tlaitkama nebo IR DO RC-5 (Philips)
   ' rizeni jasu LED dle okolniho osvetleni (fotoodporem)
   ' zmna asu Lto/Zima do roku 2035
   '
   ' v 1.0 (1.3.2014) - 86%
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '
   '***********************************************************************

$regfile = "m168def.dat"                                    'Soubor s deklaracemi
$crystal = 8000000                                          'Kmitoet osciltoru v Hz
'Fuses set: High=DC  Low=CD  Ext=F9

Declare Sub Displej
Declare Sub Osvetleni
Declare Sub Hodiny
Declare Sub Infra_do
Declare Sub Minuty_set
Declare Sub Hodiny_set
Declare Sub Datum
Declare Sub Preved
Declare Sub Letni_zimni_cas
Declare Sub Alarm_proved
Declare Sub Cti_teplotu
Declare Sub Teplotu_na_displej
Declare Sub Teplota_min_max
Declare Sub Tlacitka
Declare Sub Zobraz_den

Config Portc = Output                                       'In=PC1,PC2,PC4,PC5
Config Portd = Output                                       'In=PD3 (INT1)
Config Portb.0 = Output                                     'Out=PB1,PB2

'posuvne reg. - LED displeje
Strobe Alias Portd.5
Clk Alias Portd.6
Dat Alias Portd.7
Const Shift_delay = 20                                      ' shift delay in microseconds for 74HCT595

Dim Displej1 As Byte , Displej2 As Byte , Displej3 As Byte , Displej4 As Byte
2tecka Alias Portd.0 : Reset 2tecka

Regul Alias Pwm1a                                           'Oc1a
Config Portb.1 = Output
Config Timer1 = Pwm , Prescale = 64 , Compare A Pwm = Clear Down
Enable Timer1

'NC3 - Portc.0
'NC2 - portd.4
'NC1 - portb.0

Config Portb.2 = Output : Reset Portb.2
Piezo Alias Portb.2

Dim Tis As Word
Dim Sto As Word                                             'DESitky (most temperature digit)
Dim Des As Word                                             'JEDnotky (least temperature digit)
Dim Jed As Word                                             'desetiny (fraction temperature digit)
Dim Hodnota As Word , Hod_pom As Word

Dim Leto_zima As Eram Byte At 1                             'je-li 255 - povolena zmena casu
Dim Alarm As Eram Byte At 5                                 'Dim Alarm_zaloha As Eram Byte At 10
Dim Alarm_hod As Eram Byte At 6
Dim Alarm_min As Eram Byte At 7
Dim Alarm_day As Eram Byte At 8
Dim Zobrazeni As Eram Byte At 9
If Zobrazeni > 3 Then Zobrazeni = 3                         'prednastaveni po naprogramovani (zobrazi cas, tep, datum)

Dim Sirena As Byte : Sirena = 10
Dim Menu As Byte
Dim A1 As Byte , A2 As Byte , A3 As Byte , A4 As Byte       'pomocne
Dim Datuma As Bit : Datuma = 0                              'pro zobrazeni datumu v rezimu hodin vedle dne v tydnu

'------------ tlacitka ------------------
Config Portb.4 = Input : Set Portb.4
Config Portb.5 = Input : Set Portb.5
Config Portc.4 = Input : Set Portc.4
Config Portc.5 = Input : Set Portc.5
Tlac1 Alias Pinb.5
Tlac2 Alias Pinb.4
Tlac3 Alias Pinc.5
Tlac4 Alias Pinc.4

'---------------- ADC ----------------------
Config Portc.1 = Input
Dim Svit As Word
Dim Svitx As Word                                           'single
Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' konfigurace AD pevodnku

' ------------- RTC --- DS3231 ------------------
Config Sda = Portd.2
Config Scl = Portd.1
Const Ds3231w = &B11010000                                  'write
Const Ds3231r = &B11010001                                  'read

'prvotni nastaveni SQW vstupu DS3231 na 1Hz
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds3231w                                         ' send address
   I2cwbyte 14                                              ' starting address
   I2cwbyte &B00000000                                      ' SQWE - 1Hz(send Data To Control Register)
   I2cstop
   Waitms 10

Dim _sec As Byte , Sec1 As Byte , Sec2 As Byte
Dim _min As Byte , _min_bcd As Byte , Min1 As Byte , Min2 As Byte
Dim _hod As Byte , _hod_bcd As Byte , Hod1 As Byte , Hod2 As Byte
Dim Weekday As Byte , Day As Byte , Month As Byte , Year As Byte
Dim Sekunda As Bit : Sekunda = 0

'---------- ext. preruseni od RTC DS3231 - 1Hz ------------------
Config Pind.3 = Input : Set Portd.3                         'Ddrd.3 = 0   pin INT1 vstup ; pull-up
Eicra.isc10 = 1                                             'nastane zmnou rovn na pinu INT1
Enable Int1                                                 'Konfigurace peruen INT1, od DS3231 - 1Hz
On Int1 Sekundovy_preruseni                                 'pi peruen sko na podprogram sekundovy_preruseni

'------------ DS18B20 ----- 1wire -----------------------------------------------------
Config 1wire = Portc.3                                      'cidlo zapojene na PortC.3
Dim Dsid1(8) As Byte                                        'Dallas ID 64 bits incl CRC
Dim Sc(9) As Byte                                           'Scratchpad 0-8 72 bits incl CRC, explanations for DS18b20

'registry a nastaveni pro mereni teploty
Dim Teplota As Word                                         'nactena a upravena teplota
Dim Tep_nula As Bit                                         'inforamce zda je hodnota teploty - nebo + (1-minus, 0-plus)
Dim Teplotas As Word
Dim Teplota_min As Word
Dim Teplota_max As Word

'-----------------------------------------------------------
'prijimac dalkoveho ovladani TSOP-31236
Config Pinc.2 = Input : Set Portc.2                         'pull-up
Config Rc5 = Pinc.2                                         ', Timer = 2
Dim Address As Byte
Dim Command As Byte
Enable Timer2

'===============================================================================
Disable Interrupts

Displej1 = Lookup(13 , Tabulka)                             'P
Displej2 = Lookup(14 , Tabulka)                             'A
Displej3 = Lookup(15 , Tabulka)                             'J
Displej4 = Lookup(14 , Tabulka)                             'A
Call Displej

' Nacti teplotu DS18B20
Dsid1(1) = 1wsearchfirst()
   1wreset
   1wwrite &HCC
   1wwrite &H44
   Waitms 800
If Dsid1(8) = Crc8(dsid1(1) , 7) Then                       ' Control that the received CRC match the calculated
   Set Piezo : Waitms 15 : Reset Piezo                      'je-li kontrola v poradku tak pipni
End If

Teplota_min = 1500
Teplota_max = 1

Displej1 = Lookup(29 , Tabulka)                             'H
Displej2 = Lookup(18 , Tabulka)                             'o.
Displej3 = Lookup(1 , Tabulka)                              '1.
Displej4 = Lookup(0 , Tabulka)                              '0
Displej3 = Displej3 + &B00000001
Displej2 = Displej2 + &B00000001
Call Displej
Wait 1

Enable Interrupts

'===============================================================================
'================================= START =======================================

Do

Call Tlacitka
Call Infra_do

'kazdou zapocatou sekundu proved:
If Sekunda = 1 Then
   'pri shode casu nastaveneho alarmu a RTC      'je-li povoleny alarm tak jdi na jeho vykonani (0 = alarm zakazany)
   If Alarm = 1 And Alarm_hod = _hod And Alarm_min = _min And _sec = 0 Then Call Alarm_proved

   If _sec = 0 Or _sec = 15 Or _sec = 30 Or _sec = 45 Then  'kazdou 15. sekundu zkontroluj a zobraz
      Select Case Zobrazeni
         Case 0 : Call Hodiny                               'pouze hodiny
         Case 1 : If _sec = 0 Or _sec = 30 Then             'den + datum
                   Datuma = 1
                   Call Zobraz_den
                   Wait 1
                   End If
         Case 2 : If _sec = 15 Or _sec = 45 Then            'teplota
                   Command = 1                              'dlouhy cteni 12bit
                   Call Cti_teplotu
                   Call Displej
                   Wait 1
                   End If
         Case 3 : If _sec = 0 Or _sec = 30 Then             'den + datum
                      Datuma = 1
                      Call Zobraz_den
                      Wait 1
                   End If
                   If _sec = 15 Or _sec = 45 Then           'teplota
                      Command = 1                           'dlouhy cteni 12bit
                      Call Cti_teplotu
                      Call Displej
                      Wait 1
                   End If
      End Select

   Else
      Call Hodiny
   End If

 '-------------- novy den (v 0hod:0min :5sec)  -> vynuluj min/max teploty ------------------------
   If _hod = 0 And _min = 0 And _sec = 5 Then
      Teplota_min = 1500                                    'vynulovani teplot kazdy novy den
      Teplota_max = 1
   End If

Sekunda = 0
End If


If Sirena > 0 And Sirena < 10 Then
      Set Piezo : Waitms 100 : Reset Piezo : Waitms 75 : Set Piezo : Waitms 100 : Reset Piezo : Waitms 150
      Set Piezo : Waitms 90 : Reset Piezo : Waitms 70 : Set Piezo : Waitms 90 : Reset Piezo : Waitms 130
      Set Piezo : Waitms 80 : Reset Piezo : Waitms 65 : Set Piezo : Waitms 80 : Reset Piezo : Waitms 100
      Set Piezo : Waitms 60 : Reset Piezo : Waitms 50 : Set Piezo : Waitms 500 : Reset Piezo : Waitms 300
      Incr Sirena
      If Sirena > 3 Then Sirena = 0
End If

Waitms 50

Loop

End

'============================= STOP ============================================
'===============================================================================


'-------------------------------------------------------------------------------
'1x za sekundu (1Hz) nacti data z RTC - preruseni od pinu SQWE
Sekundovy_preruseni:

If Pind.3 = 0 Then
   Sekunda = 1
   2tecka = 1                                               'rozsvit 2tecku
           I2cstart                                         ' Generate start code
           I2cwbyte Ds3231w                                 ' send address
           I2cwbyte 0                                       ' start address in DS3231
           I2cstart                                         ' Generate start code
           I2cwbyte Ds3231r                                 ' send address
           I2crbyte _sec , Ack                              ' sec
           I2crbyte _min , Ack                              ' MINUTES
           I2crbyte _hod , Ack                              ' Hours
           I2crbyte Weekday , Ack                           ' WEEK DAY
           I2crbyte Day , Ack                               ' DAY
           I2crbyte Month , Ack                             ' MONTH
           I2crbyte Year , Nack                             ' YEAR
           I2cstop

           _sec = Makedec(_sec) : _min = Makedec(_min) : _hod = Makedec(_hod)       'preved nactena data na Dec
           Weekday = Makedec(weekday) : Day = Makedec(day) : Month = Makedec(month) : Year = Makedec(year)

   If Leto_zima <> 0 And _hod = 3 And _min = 0 Then Call Letni_zimni_cas       'kdyz neni zakazany prechod na lezni/zimni cas a jsou 3hod 0min rno

Else
   Sekunda = 0
   2tecka = 0                                               'zhasni 2tecku
End If

Return

'-------------------- alarm --------------------------------------------------------
Sub Alarm_proved                                            'pri shode hodin, minut, sekund aktivuj prislusny druhu alarmu (zvukovy, tichy-opto nebo oboje)
   Select Case Alarm_day
      Case 0 : Sirena = 1                                   'alarm vzdy
      Case 1 To 7 : If Weekday = Alarm_day Then Sirena = 1  'jednotlive dny
      Case 8 : If Weekday > 1 And Weekday < 7 Then Sirena = 1       ' Po-Pa
      Case 9 : If Weekday = 1 Or Weekday = 7 Then Sirena = 1       ' So-Ne
      Case Else : Sirena = 0
   End Select
End Sub

'-------------------------------------------------------------------------------
Sub Minuty_set                                              'inkrementuj minuty, vynuluj sekundy a 0s + _min zapis do DS3231
         Incr _min
         If _min > 59 Then _min = 0
         _min_bcd = Makebcd(_min)
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 0                                         ' starting address
         I2cwbyte 0                                         ' Send Data to SECONDS = 0
         I2cwbyte _min_bcd                                  ' Send Data to MINUTES
         I2cstop
   Call Hodiny
End Sub
'-------------------------------------------------------------------------------
Sub Hodiny_set
         Incr _hod
         If _hod > 23 Then _hod = 0
         _hod_bcd = Makebcd(_hod)                           ' meziprevod na registr _hod_bcd je potreba, protoze by se ted prevedene data na BCD znovu prevedly pri vysilani na displej na dalsi BCD a vznikla by blbost.
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 2                                         ' starting address
         I2cwbyte _hod_bcd
         I2cstop
   Call Hodiny
End Sub
'-------------------------------------------------------------------------------
Sub Datum
         Day = Makebcd(day)
         Month = Makebcd(month)
         Year = Makebcd(year)
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 3                                         ' starting address
         I2cwbyte Weekday                                   ' WeekDay
         I2cwbyte Day                                       ' DAY
         I2cwbyte Month                                     ' MONTH
         I2cwbyte Year                                      ' year
         I2cstop
End Sub

'---------------------prevede hodiny pro zobrazeni na displej ----------------------------------------------
Sub Hodiny
'rozdeli dvouciferne cislo _min na dve jednociferna do min1 a min2
   Hod2 = Makebcd(_hod)
   Hod1 = Hod2
   Hod2 = Hod2 And &B0000_1111
   Shift Hod1 , Right , 4
   If Hod1 = 0 Then Hod1 = 10                               'kdyz je v desitkach 0, tak ji nezobrazuj (odpovida pozici 10 v tabulce dat)

   Min2 = Makebcd(_min)                                     'prevod na BCD
   Min1 = Min2
   Min2 = Min2 And &B0000_1111                              'odmaskuj (vymaz "desitky")
   Shift Min1 , Right , 4                                   'posun obsah Min1 o 4 pozice doprava => vycleni jednociferne cislo desitek
   If Menu > 0 And Min1 = 0 Then Min1 = 10                  'kdyz je v desitkach 0 - pri nastavovani menu, tak ji nezobrazuj

   Displej1 = Lookup(hod1 , Tabulka)                        'podivej se do tabulky, preved a uloz do displej1
   Displej2 = Lookup(hod2 , Tabulka)
   Displej3 = Lookup(min1 , Tabulka)
   Displej4 = Lookup(min2 , Tabulka)
   Call Displej
End Sub

'-------------------------------------------------------------------------------
'nacte teplotu z DS18B20
Sub Cti_teplotu
   1wreset                                                  ' reset the bus
   1wwrite &HCC                                             ' skip rom
   1wwrite &H44                                             ' Convert T
   Waitms 10                                                'kratka pauza - aby se nezdrzoval beh programu
   If Command = 1 Then
      Command = 0
      Disable Int1
      Waitms 740                                            'convert 12b time 750ms - pro spravne nacteni teploty pri jednorazovem zobrazeni
      Enable Int1
   End If

  1wverify Dsid1(1)                                         'Issues the "Match ROM "
  If Err = 1 Then
    Displej1 = Lookup(16 , Tabulka)                         'E
    Displej2 = Lookup(17 , Tabulka)                         'r
    Displej3 = Lookup(17 , Tabulka)                         'r
    Displej4 = &B00000000
    Gosub Displej
    Waitms 200
  Elseif Err = 0 Then                                       'lcd " Sensor found"
    1wwrite &HBE
    Sc(1) = 1wread(9)                                       'read bytes into array
    If Sc(9) = Crc8(sc(1) , 8) Then
      If Sc(2) > 127 Then                                   'kdyz je pod nulou tak je Sc(2) > 127,
         Tep_nula = 1                                       'informace o zaporne teplote (zaroven i kod z tabulky pro zobrazeni minusu)
         Toggle Sc(2)                                       'zneguj nactene hodnoty
         Toggle Sc(1)
         Teplota = Makeint(sc(1) , Sc(2))                   'kombinace MSB & LSB teploty
         Teplota = Teplota * 10
         Teplota = Teplota / 16                             'decimal format x10
         Teplota = Teplota + 1
         If Teplota > 550 Then Teplota = 550                'omezeni na -55,0C
         Teplotas = Teplota + 100                           'umele zvyseni
      Else
         Tep_nula = 0                                       'teplota nad nulou
         Teplota = Makeint(sc(1) , Sc(2))                   'kombinace MSB & LSB teploty
         Teplota = Teplota * 10
         Teplota = Teplota / 16                             'decimal format x10
         If Teplota > 999 Then Teplota = 999                'omezeni na 99,9C
         Teplotas = Teplota + 200
      End If

         If Teplota_min > Teplotas Then Teplota_min = Teplotas
         If Teplota_max < Teplotas Then Teplota_max = Teplotas

      Hodnota = Teplota
      Call Preved
      Call Teplotu_na_displej
    End If
  End If
End Sub

'-------------------------------------------------------------------------------

Sub Teplotu_na_displej
      If Sto = 0 Then Sto = 10                              'nezobrazuj zbytecnou nulu
      'pokud by hodnota zaporna teplota byla vetsi nez 10'C, tak zrus zobrazeni C a posun displej doprava
      If Sto <> 10 And Tep_nula = 1 Then                    'zaporna teplota -10,0 az -55,5C
         Displej1 = Lookup(11 , Tabulka)                    'podivej se do tabulky, preved a uloz do displej1 - znak "-"
         Displej2 = Lookup(sto , Tabulka)
         Displej3 = Lookup(des , Tabulka)
         Displej4 = Lookup(jed , Tabulka)
         Displej3 = Displej3 + &B00000001                   'des. tecka
      Else
      'klasicke zobrazeni C
         If Tep_nula = 1 Then Sto = 11                      'kdyz je pod nulou a teplota neni mensi nez -10C tak nahrad zbytecne (vynechane) desitky minusem
         Displej1 = Lookup(sto , Tabulka)                   'podivej se do tabulky, preved a uloz do displej1
         Displej2 = Lookup(des , Tabulka)
         Displej3 = Lookup(jed , Tabulka)
         Displej4 = Lookup(12 , Tabulka)                    'C
         Displej2 = Displej2 + &B00000001                   'des. tecka
      End If
End Sub

'-------------------------------------------------------------------------------
Sub Teplota_min_max
   Tep_nula = 0
      If Teplotas < 200 Then
         Teplota = Teplotas - 100
         Tep_nula = 1
      End If
      If Teplotas >= 200 Then Teplota = Teplotas - 200

   Hodnota = Teplota
   Call Preved
   Call Teplotu_na_displej
   Call Displej
   Waitms 900
End Sub
'-------------------------------------------------------------------------------

Sub Tlacitka
'tl.1 - menu      tl.2 - min. teplota dnesni       tl.3 - max. teplota dnesni       tl.4 - teplota z DS18B20

If Tlac2 = 0 Or Command = 17 Then
   Teplotas = Teplota_min
   Call Teplota_min_max
   Wait 2
End If

If Tlac3 = 0 Or Command = 16 Then
   Teplotas = Teplota_max
   Call Teplota_min_max
   Wait 2
End If

If Tlac4 = 0 Or Command = 1 Then                            'Tlacitkem 4 nebo DO tl.1 precti a zobraz teplotu
   Command = 1                                              'pro delsi prevod teploty 750ms pri jednorazovem zobrazeni - spravne nacteni
   Set Piezo : Waitms 15 : Reset Piezo
   Call Cti_teplotu
   Call Displej
   Wait 1
End If

'------- Menu ----------------------------

Menu = 0
If Tlac1 = 0 Or Command = 82 Then                           'Tlacitkem 1 nebo DO tlacitkem Menu vyvolej Nastaveni (SET)
Disable Int1                                                'zakaz preruseni od RTC
2tecka = 0

   Displej1 = Lookup(21 , Tabulka)                          'S
   Displej2 = Lookup(16 , Tabulka)                          'E
   Displej3 = Lookup(20 , Tabulka)                          't
   Displej4 = &B00000000
   Call Displej
   Waitms 100
   Command = 0
   Set Piezo : Waitms 150 : Reset Piezo

   Do
     Waitms 100
   Loop Until Tlac1 <> 0 And Command <> 82
     Waitms 100

     Do
       Call Infra_do
       If Tlac1 = 0 Or Command = 82 Then Goto Konecmenu
       If Tlac3 = 0 Then Incr Menu
       If Tlac2 = 0 Then Decr Menu
       Call Osvetleni
       Waitms 100

         Select Case Menu
            Case 0 : Waitms 500
                     Menu = 1                               'po zapnuti menu pockej 0,5s
           '---------------------------------------------------
            Case 1 : Displej1 = Lookup(22 , Tabulka)        'C
                     Displej2 = Lookup(14 , Tabulka)        'A
                     Displej3 = Lookup(21 , Tabulka)        'S
                     Displej4 = &B00000000
                     Call Displej

                     If Tlac4 = 0 Or Command = 87 Then
                       Set Piezo : Waitms 40 : Reset Piezo
                       Command = 0
                       Do                                   'cekaci smycka
                       Waitms 100
                       Loop Until Tlac4 <> 0 And Command <> 87       'dokud neni rozepnuto tlac4 nebo neni povel OK z DO
                       Waitms 100
                       _sec = 0

                      Do
                        2tecka = 1
                        Call Infra_do
                        Waitms 90
                        If Tlac2 = 0 Or Command = 17 Then Call Hodiny_set
                        If Tlac3 = 0 Or Command = 16 Then Call Minuty_set
                        Call Hodiny
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo
                      2tecka = 0
                      Menu = 2
                      End If
          '---------------------------------------------------     nastavebni datumu (den - mesic / rok / den v tydnu)
            Case 2 : Displej1 = Lookup(26 , Tabulka)        'd
                     Displej2 = Lookup(14 , Tabulka)        'A
                     Displej3 = Lookup(20 , Tabulka)        't
                     Displej4 = Lookup(16 , Tabulka)        'E
                     Call Displej

                     If Tlac4 = 0 Or Command = 87 Then
                       Set Piezo : Waitms 40 : Reset Piezo
                       Command = 0

                       Do                                   'cekaci smycka
                       Waitms 100
                       Loop Until Tlac4 <> 0 And Command <> 87       'dokud neni rozepnuto tlac2 nebo neni povel OK z DO
                       Waitms 100

                     Displej1 = Lookup(26 , Tabulka)        'd         (den)
                     Displej1 = Displej1 + &B00000001       'des. tecka
                     Displej2 = &B00000000
                     Displej3 = Lookup(23 , Tabulka)        'n         (mesic)
                     Displej4 = Lookup(23 , Tabulka)        'n
                     Call Displej
                     Wait 1

                      Do                                    'den : mesic
                        Call Infra_do
                        Waitms 100
                        If Tlac2 = 0 Or Command = 17 Then Incr Day
                        If Tlac3 = 0 Or Command = 16 Then Incr Month
                           If Day > 31 Then Day = 1
                           If Month > 12 Then Month = 1
                           _min = Month
                           _hod = Day
                           Call Hodiny
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo

                       Command = 0
                       Do                                   'cekaci smycka
                       Waitms 100
                       Loop Until Tlac4 <> 0 And Command <> 87       'dokud neni rozepnuto tlac2 nebo neni povel OK z DO
                       Waitms 100

                      Do                                    'rok = 2000+(0-99)
                        Call Infra_do
                        Waitms 100
                        If Tlac2 = 0 Or Command = 17 Then Decr Year
                        If Tlac3 = 0 Or Command = 16 Then Incr Year
                           If Year > 99 Then Year = 0
                           Hodnota = 2000 + Year
                           Call Preved
                           Displej1 = Lookup(tis , Tabulka)
                           Displej2 = Lookup(sto , Tabulka)
                           Displej3 = Lookup(des , Tabulka)
                           Displej4 = Lookup(jed , Tabulka)
                           Call Displej
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo

                       Command = 0
                       Do                                   'cekaci smycka
                       Waitms 100
                       Loop Until Tlac4 <> 0 And Command <> 87       'dokud neni rozepnuto tlac2 nebo neni povel OK z DO
                       Waitms 100

                      Do                                    'nastaveni dne v tydnu (1-Ne ... 7-So)
                        Call Zobraz_den
                        Call Infra_do
                        Waitms 100
                        If Tlac2 = 0 Or Command = 17 Then Decr Weekday
                        If Tlac3 = 0 Or Command = 16 Then Incr Weekday
                           If Weekday < 1 Then Weekday = 1
                           If Weekday > 7 Then Weekday = 7
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo

                      Call Datum                            'zapis nastavene datum (Day, Month, Year) do DS3231
                      Menu = 3
                     End If

   '---------------------------------------------------   nastav hod + min Alarmu1
            Case 3 : Displej1 = Lookup(14 , Tabulka)        'A
                     Displej2 = Lookup(24 , Tabulka)        'L
                     Displej3 = Lookup(14 , Tabulka)        'A
                     Displej4 = Lookup(17 , Tabulka)        'r
                     Call Displej

                     If Tlac4 = 0 Or Command = 87 Then
                        Menu = 31
                        Set Piezo : Waitms 40 : Reset Piezo
                     End If

            Case 31 : Command = 0
                      _hod = Alarm_hod                      'nacte posledni ulozene data
                      _min = Alarm_min
                      _sec = 0
                      2tecka = 1
                       Do                                   'cekaci smycka
                       Waitms 100
                       Loop Until Tlac4 <> 0 And Command <> 87       'dokud neni rozepnuto tlac nebo neni povel OK z DO
                       Waitms 100
                      Do
                        Call Infra_do
                        Waitms 100
                        If Tlac2 = 0 Or Command = 17 Then Incr _hod
                        If Tlac3 = 0 Or Command = 16 Then Incr _min
                           If _hod > 23 Then _hod = 0
                           If _min > 59 Then _min = 0
                           Alarm_hod = _hod
                           Alarm_min = _min
                           Call Hodiny
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo
                      2tecka = 0
                      Menu = 32
            Case 32 : Weekday = Alarm_day
                      Do
                        Call Zobraz_den
                        Call Infra_do
                        Waitms 100
                        If Tlac2 = 0 Or Command = 17 Then Decr Weekday
                        If Tlac3 = 0 Or Command = 16 Then Incr Weekday
                           If Weekday > 10 Then Weekday = 0
                      Loop Until Tlac4 = 0 Or Command = 87
                      Set Piezo : Waitms 40 : Reset Piezo
                           If Weekday = 10 Then Alarm = 0   'kdyz je nastaveno 10 - alarm vypnut - neukladej den
                           If Weekday < 10 Then
                              Alarm_day = Weekday
                              Alarm = 1                     'alarm povolen
                           End If
                      Alarm = 1
                      Menu = 4

           '---------------------------------------------------    povoleni automaticke zmeny LEtniho / ZImniho casu
            Case 4 : Displej1 = Lookup(24 , Tabulka)        'L          (LEtni)
                     Displej2 = Lookup(16 , Tabulka)        'E
                     Displej3 = Lookup(27 , Tabulka)        'Z          (ZImni)
                     Displej4 = Lookup(28 , Tabulka)        'i
                     Call Displej
                     If Tlac4 = 0 Or Command = 87 Then
                        Menu = 41
                        Set Piezo : Waitms 40 : Reset Piezo
                     End If
            Case 41 : Displej1 = Lookup(14 , Tabulka)       'A
                      Displej2 = Lookup(23 , Tabulka)       'n
                      Displej3 = Lookup(18 , Tabulka)       'o
                      Displej4 = Lookup(10 , Tabulka)
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 5
                        Leto_zima = 255
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 42 : Displej1 = Lookup(23 , Tabulka)       'n
                      Displej2 = Lookup(16 , Tabulka)       'E
                      Displej3 = Lookup(10 , Tabulka)
                      Displej4 = Lookup(10 , Tabulka)
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 5
                        Leto_zima = 0                       'zakaz aut. zmenu letniho_zimniho casu
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 43 : Menu = 42
           '---------------------------------------------------    zobrazeni casu / datumu / teploty
            Case 5 : Displej1 = Lookup(26 , Tabulka)        'd
                     Displej2 = Lookup(28 , Tabulka)        'i
                     Displej3 = Lookup(21 , Tabulka)        'S
                     Displej4 = Lookup(13 , Tabulka)        'P
                     Call Displej
                     If Tlac4 = 0 Or Command = 87 Then
                        Menu = 51
                        Set Piezo : Waitms 40 : Reset Piezo
                     End If
            Case 51 : Displej1 = Lookup(29 , Tabulka)       'H
                      Displej2 = Lookup(18 , Tabulka)       'o
                      Displej3 = Lookup(26 , Tabulka)       'd
                      Displej4 = Lookup(10 , Tabulka)
                      Displej3 = Displej3 + &B00000001      'des. tecka
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 6
                        Zobrazeni = 0
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 52 : Displej1 = Lookup(26 , Tabulka)       'd
                      Displej2 = Lookup(16 , Tabulka)       'E
                      Displej3 = Lookup(23 , Tabulka)       'n
                      Displej4 = Lookup(10 , Tabulka)
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 6
                        Zobrazeni = 1
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 53 : Displej1 = Lookup(20 , Tabulka)       't
                      Displej2 = Lookup(16 , Tabulka)       'E
                      Displej3 = Lookup(13 , Tabulka)       'P
                      Displej3 = Displej3 + &B00000001      'des. tecka
                      Displej4 = Lookup(10 , Tabulka)
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 6
                        Zobrazeni = 2
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 54 : Displej1 = Lookup(26 , Tabulka)       'd  den
                      Displej2 = Lookup(16 , Tabulka)       'E
                      Displej3 = Lookup(20 , Tabulka)       't   +teplota
                      Displej4 = Lookup(16 , Tabulka)       'E
                      Displej2 = Displej2 + &B00000001      'des. tecka
                      Call Displej
                      If Tlac4 = 0 Or Command = 87 Then
                        Menu = 6
                        Zobrazeni = 3
                        Set Piezo : Waitms 40 : Reset Piezo
                      End If
            Case 55 : Menu = 54
            Case 6 : Menu = 5
            Case 99 : Goto Konecmenu
           '---------------------------------------------------
            Case Else : Menu = 1

         End Select

      Loop

Konecmenu:
Set Piezo : Waitms 50 : Reset Piezo : Waitms 25 : Set Piezo : Waitms 50 : Reset Piezo       '2x pipne piezo
Enable Int1                                                 'povol preruseni od RTC

End If

Command = 0

End Sub

'-------------------------------------------------------------------------------

Sub Zobraz_den
      A1 = 10 : A2 = 10
   Select Case Weekday
      Case 2 : A3 = 13                                      'pondeli                            '
               A4 = 18
      Case 3 : A3 = 19
               A4 = 20
      Case 4 : A3 = 21
               A4 = 20
      Case 5 : A3 = 22
               A4 = 20
      Case 6 : A3 = 13
               A4 = 14
      Case 7 : A3 = 21                                      'sobota
               A4 = 18
      Case 1 : A3 = 23                                      'nedele
               A4 = 16
      Case 8 : A3 = 13                                      'POnedeli-PAtek
               A4 = 18
               A1 = 13
               A2 = 14
      Case 9 : A3 = 21                                      'SObota-NEdele
               A4 = 18
               A1 = 23
               A2 = 16
      Case 0 : A3 = 13                                      'PO-NE - furt
               A4 = 18
               A1 = 23
               A2 = 16
      Case 10 : A3 = 11                                     '---- vypnuto
               A4 = 11
               A1 = 11
               A2 = 11
   End Select

'pri zobrazeni dne v tydnu (Po-Ne) v rezimu hodin, zobraz vpravo i datum (1.-31.)
   If Datuma = 1 Then
      A2 = Makebcd(day)                                     'prevod na BCD
      A1 = A2
      A2 = A2 And &B0000_1111                               'odmaskuj (vymaz "desitky")
      Shift A1 , Right , 4                                  'posun obsah A1 o 4 pozice doprava => vycleni jednociferne cislo desitek
      If A1 = 0 Then A1 = 10
      Datuma = 0
   End If

   Displej1 = Lookup(a3 , Tabulka)                          'podivej se do tabulky, preved a uloz do displej1
   Displej2 = Lookup(a4 , Tabulka)
   Displej3 = Lookup(a1 , Tabulka)
   Displej4 = Lookup(a2 , Tabulka)
   If Weekday <> 10 Then Displej2 = Displej2 + &B00000001   'des. tecka
   Call Displej
End Sub

'-------------------------------------------------------------------------------

Sub Infra_do
   Command = 0
   Getrc5(address , Command)
   Command = Command And &B01111111

'Command = 17 - Teplota_min
'Command = 16 - Teplota_max
'Command = 1  - Teplota aktualni

If Command = 10 Then Command = 87                           'OK
If Command = 40 Then Command = 82                           'menu
If Command = 12 Then Menu = 99                              'konec menu

If Command = 3 Or Command = 34 Then                         'zobraz den+datum
   Datuma = 1
   Call Zobraz_den
   Wait 1
End If

If Command = 32 Then Incr Menu
If Command = 33 Then Decr Menu

If Command = 109 Or Command = 13 Then                       'rychle vypnuti/zapnuti alarmu
   If Alarm = 1 Then                                        'alarm nastaven
      Alarm = 0                                             'tak Ho Vypni
      Displej1 = Lookup(14 , Tabulka)                       'A.    Alarm off
      Displej2 = Lookup(18 , Tabulka)                       'o
      Displej3 = Lookup(25 , Tabulka)                       'f
      Displej4 = Lookup(25 , Tabulka)                       'f
      Displej1 = Displej1 + &B00000001                      'des. tecka
      Set Piezo : Waitms 100 : Reset Piezo
   Else
      Alarm = 1                                             'obnov alarm
      Displej1 = Lookup(14 , Tabulka)                       'A.    Alarm on
      Displej2 = &B00000000
      Displej3 = Lookup(18 , Tabulka)                       'o
      Displej4 = Lookup(23 , Tabulka)                       'n
      Displej1 = Displej1 + &B00000001                      'des. tecka
      Set Piezo : Waitms 30 : Reset Piezo
   End If
      Call Displej
   Wait 1
End If

End Sub
'-------------------------------------------------------------------------------

'zmeri intenzitu osvetleni na fotoodporu a dle toho pak upravi intenzitu sviceni displeje a dle nastaveni i barvu
Sub Osvetleni
   Start Adc                                                'Zapne ADC prevodnik
      Svit = Getadc(1)                                      'a nacte hodnotu, kterou zmeril ADC1 (PC1)
   Stop Adc

   Svitx = Svit
   If Svit < 20 Then Svitx = Svit * 3
   If Svit < 40 And Svit >= 20 Then Svitx = Svit * 2

   If Svitx > 255 Then Svitx = 255                          'omezeni na max 255
   If Svitx < 8 Then Svitx = 8

   If _hod >= 21 And _hod < 6 And Svitx < 10 Then Svitx = 2 'omezeni na min 2 (od 21h do 6 rano, aby displej v noci moc nezaril po okoli)
   Regul = Svitx

End Sub

'-------------------------------------------------------------------------------
'automaticka zmena letniho (3-brezen) / zimniho (10-rijen) casu ve 3hod rano od roku 2014-2035
Sub Letni_zimni_cas

If Month = 3 And Leto_zima <> 3 Then                        'prechod na letni cas +1 hodina (Posledn nedle v beznu)
   If Year = 14 And Day = 30 Then Goto Hod_plus
   If Year = 15 And Day = 29 Then Goto Hod_plus
   If Year = 16 And Day = 27 Then Goto Hod_plus
   If Year = 17 And Day = 26 Then Goto Hod_plus
   If Year = 18 And Day = 25 Then Goto Hod_plus
   If Year = 19 And Day = 31 Then Goto Hod_plus
   If Year = 20 And Day = 29 Then Goto Hod_plus
   If Year = 21 And Day = 28 Then Goto Hod_plus
   If Year = 22 And Day = 27 Then Goto Hod_plus
   If Year = 23 And Day = 26 Then Goto Hod_plus
   If Year = 24 And Day = 31 Then Goto Hod_plus
   If Year = 25 And Day = 30 Then Goto Hod_plus
   If Year = 26 And Day = 29 Then Goto Hod_plus
   If Year = 27 And Day = 28 Then Goto Hod_plus
   If Year = 28 And Day = 26 Then Goto Hod_plus
   If Year = 29 And Day = 25 Then Goto Hod_plus
   If Year = 30 And Day = 31 Then Goto Hod_plus
   If Year = 31 And Day = 30 Then Goto Hod_plus
   If Year = 32 And Day = 28 Then Goto Hod_plus
   If Year = 33 And Day = 27 Then Goto Hod_plus
   If Year = 34 And Day = 26 Then Goto Hod_plus
   If Year = 35 And Day = 25 Then Goto Hod_plus

   Goto Konec_lz
   Hod_plus:
      Leto_zima = 3                                         'prechod na letni cas byl proveden
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 2                                         ' starting address
         I2cwbyte &B00000100                                'BCD 4
         I2cstop
End If

If Month = 10 And Leto_zima <> 9 Then                       'prechod na zimni (standatrni) cas -1 hodina (Posledn nedle v jnu)
   If Year = 14 And Day = 26 Then Goto Hod_minus
   If Year = 15 And Day = 25 Then Goto Hod_minus
   If Year = 16 And Day = 30 Then Goto Hod_minus
   If Year = 17 And Day = 29 Then Goto Hod_minus
   If Year = 18 And Day = 28 Then Goto Hod_minus
   If Year = 19 And Day = 27 Then Goto Hod_minus
   If Year = 20 And Day = 25 Then Goto Hod_minus
   If Year = 21 And Day = 31 Then Goto Hod_minus
   If Year = 22 And Day = 30 Then Goto Hod_minus
   If Year = 23 And Day = 29 Then Goto Hod_minus
   If Year = 24 And Day = 27 Then Goto Hod_minus
   If Year = 25 And Day = 26 Then Goto Hod_minus
   If Year = 26 And Day = 25 Then Goto Hod_minus
   If Year = 27 And Day = 27 Then Goto Hod_minus
   If Year = 28 And Day = 29 Then Goto Hod_minus
   If Year = 29 And Day = 28 Then Goto Hod_minus
   If Year = 30 And Day = 27 Then Goto Hod_minus
   If Year = 31 And Day = 26 Then Goto Hod_minus
   If Year = 32 And Day = 31 Then Goto Hod_minus
   If Year = 33 And Day = 30 Then Goto Hod_minus
   If Year = 34 And Day = 29 Then Goto Hod_minus
   If Year = 35 And Day = 28 Then Goto Hod_minus

   Goto Konec_lz
   Hod_minus:
      Leto_zima = 9                                         'prechod na zimni cas byl proveden
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 2                                         ' starting address
         I2cwbyte &B00000010                                'BCD 2
         I2cstop
End If

Konec_lz:
End Sub
'-------------------------------------------------------------------------------
'prevod hodnota na Sto, des a jednotky
Sub Preved()
      Tis = Hodnota / 1000
      Hod_pom = Tis * 1000
      Hodnota = Hodnota - Hod_pom
      Sto = Hodnota / 100
      Hod_pom = Sto * 100
      Hodnota = Hodnota - Hod_pom
      Des = Hodnota / 10
      Hod_pom = Des * 10
      Hodnota = Hodnota - Hod_pom
      Jed = Hodnota
End Sub

'-------------------------------------------------------------------------------
Sub Displej
Call Osvetleni
   Shiftout Dat , Clk , Displej4 , 0 , 8 , Shift_delay      'minuty
   Shiftout Dat , Clk , Displej3 , 0 , 8 , Shift_delay      'minuty
   Shiftout Dat , Clk , Displej2 , 0 , 8 , Shift_delay      'hodiny
   Shiftout Dat , Clk , Displej1 , 0 , 8 , Shift_delay      'hodiny
   Waitms 1
   Set Strobe
   Waitms 1
   Reset Strobe
End Sub

'-------------------------------------------------------------------------------

Tabulka:                                                    '&Bxxxxxxx1 - desetinn teka        DCEGBFAt
Data &B11101110 , &B01001000 , &B10111010 , &B11011010 , &B01011100 , &B11010110 , &B11110110 , &B01001010 , &B11111110 , &B11011110 , &B00000000 , &B00010000
'       0                1           2            3           4           5           6              7           8           9          10 - tma    11  - minus
Data &B00010110 , &B00111110 , &B01111110 , &B11101000 , &B10110110 , &B00110000 , &B11110000 , &B11101100 , &B10110100 , &B11010110 , &B10100110 , &B01110000
'      12-c (c)     13-P          14-A         15-J         16-E        17-r         18-o          19-U       20-t          21-S         22-C         23-n
Data &B10100100 , &B00110110 , &B11111000 , &B10111010 , &B01000000 , &B01111100
'       24-L         25-F         26-d         27-Z          28-i         29-H

' (c) PaJa 2013-2014, www.paja-trb.cz , paja@paja-trb.cz